/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: XMLTextHeaderFooterContext.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 17:26:56 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _XMLOFF_TEXTHEADERFOOTERCONTEXT_HXX_
#define _XMLOFF_TEXTHEADERFOOTERCONTEXT_HXX_


#ifndef _XMLOFF_XMLICTXT_HXX_
#include "xmlictxt.hxx"
#endif

namespace com { namespace sun { namespace star { 
	namespace text { class XTextCursor; }
	namespace beans { class XPropertySet; }
} } }
namespace binfilter {

class XMLTextHeaderFooterContext: public SvXMLImportContext
{
	::com::sun::star::uno::Reference < 
		::com::sun::star::text::XTextCursor > xOldTextCursor;
	::com::sun::star::uno::Reference < 
		::com::sun::star::beans::XPropertySet > xPropSet;

	const ::rtl::OUString sOn;
	const ::rtl::OUString sShareContent;
	const ::rtl::OUString sText;
	const ::rtl::OUString sTextLeft;

	sal_Bool	bInsertContent : 1;
	sal_Bool 	bLeft : 1;

public:
	TYPEINFO();

	XMLTextHeaderFooterContext( SvXMLImport& rImport, sal_uInt16 nPrfx,
			const ::rtl::OUString& rLName,
		    const ::com::sun::star::uno::Reference<
					::com::sun::star::xml::sax::XAttributeList > & xAttrList,
			const ::com::sun::star::uno::Reference <
		   			::com::sun::star::beans::XPropertySet > & rPageStylePropSet,
			   sal_Bool bFooter, sal_Bool bLft );

	virtual ~XMLTextHeaderFooterContext();

	virtual SvXMLImportContext *CreateChildContext(
			sal_uInt16 nPrefix,
			const ::rtl::OUString& rLocalName,
			const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XAttributeList > & xAttrList );

	virtual void EndElement();
};


}//end of namespace binfilter
#endif
